<?php

return CRM_Core_CodeGen_SqlData::create('civicrm_uf_group')
  ->addValues([
    [
      'id' => 1,
      'name' => 'name_and_address',
      'group_type' => 'Individual,Contact',
      'title' => ts('Name and Address'),
      'frontend_title' => ts('Name and Address'),
      'is_cms_user' => 0,
      'is_reserved' => 0,
      'help_post' => NULL,
    ],
    [
      'id' => 2,
      'name' => 'supporter_profile',
      'group_type' => 'Individual,Contact',
      'title' => ts('Supporter Profile'),
      'frontend_title' => ts('Supporter Profile'),
      'is_cms_user' => 2,
      'is_reserved' => 0,
      'help_post' => '<p><strong>' . ts('The information you provide will NOT be shared with any third party organisations.') . '</strong></p><p>' . ts('Thank you for getting involved in our campaign!') . '</p>',
    ],
    [
      'id' => 3,
      'name' => 'participant_status',
      'group_type' => 'Participant',
      'title' => ts('Participant Status'),
      'frontend_title' => ts('Participant Status'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 4,
      'name' => 'new_individual',
      'group_type' => 'Individual,Contact',
      'title' => ts('New Individual'),
      'frontend_title' => ts('New Individual'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 5,
      'name' => 'new_organization',
      'group_type' => 'Organization,Contact',
      'title' => ts('New Organization'),
      'frontend_title' => ts('New Organization'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 6,
      'name' => 'new_household',
      'group_type' => 'Household,Contact',
      'title' => ts('New Household'),
      'frontend_title' => ts('New Household'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 7,
      'name' => 'summary_overlay',
      'group_type' => 'Contact',
      'title' => ts('Summary Overlay'),
      'frontend_title' => ts('Summary Overlay'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 8,
      'name' => 'shared_address',
      'group_type' => 'Contact',
      'title' => ts('Shared Address'),
      'frontend_title' => ts('Shared Address'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 9,
      'name' => 'on_behalf_organization',
      'group_type' => 'Contact,Organization',
      'title' => ts('On Behalf Of Organization'),
      'frontend_title' => ts('On Behalf Of Organization'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 10,
      'name' => 'contribution_batch_entry',
      'group_type' => 'Contribution',
      'title' => ts('Contribution Bulk Entry'),
      'frontend_title' => ts('Contribution Bulk Entry'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 11,
      'name' => 'membership_batch_entry',
      'group_type' => 'Membership',
      'title' => ts('Membership Bulk Entry'),
      'frontend_title' => ts('Membership Bulk Entry'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
    [
      'id' => 12,
      'name' => 'event_registration',
      'group_type' => 'Individual,Contact',
      'title' => ts('Your Registration Info'),
      'frontend_title' => ts('Your Registration Info'),
      'is_cms_user' => 0,
      'is_reserved' => 0,
      'help_post' => NULL,
    ],
    [
      'id' => 13,
      'name' => 'honoree_individual',
      'group_type' => 'Individual,Contact',
      'title' => ts('Honoree Individual'),
      'frontend_title' => ts('Honoree Individual'),
      'is_cms_user' => 0,
      'is_reserved' => 1,
      'help_post' => NULL,
    ],
  ]);
